#include "djstop.h"

void init_scheduling(void)
{
    FILE *fp;
    char buffer[80];
    int row = 0;
#if (__DEBUG)
	int i, j;
#endif
    
    if((fp = fopen("schedule.conf","r")) == NULL) {
		fprintf(stdout, "Can't open schedule file\n");
		exit(1);
    }

	while(fgets(buffer, 80, fp) != NULL) {
		if ( buffer[0] != '#' )	{			// ּ line skip
			sscanf(buffer, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
        	&schedule[row][0],&schedule[row][1],
	  		&schedule[row][2],&schedule[row][3],&schedule[row][4],&schedule[row][5],
	    	&schedule[row][6],&schedule[row][7],&schedule[row][8],&schedule[row][9],
	    	&schedule[row][10],&schedule[row][11],&schedule[row][12],&schedule[row][13],
	    	&schedule[row][14],&schedule[row][15],&schedule[row][16],&schedule[row][17],
	    	&schedule[row][18],&schedule[row][19],&schedule[row][20],&schedule[row][21],
	    	&schedule[row][22],&schedule[row][23]) ;
			row++;
		}
    }

	fclose(fp);

#if (__DEBUG) 
	for (i=0;i<7;i++) {
		for (j=0;j<24;j++) {
			fprintf(stdout,"%d ", schedule[i][j]);
		}
		fprintf(stdout,"\n");
	}
#endif
}

// 층  ˶ ñ׳ ڵ鷯
void sig_alarm(int signo)
{
    time_t    current;
    struct tm *ltime;
    int wday, hour, min;
    
    while(1) {
        current = time(NULL);
        ltime = localtime(&current);
        wday  = ltime->tm_wday;
        hour  = ltime->tm_hour;
        min   = ltime->tm_min;
	
		//α׷  Ȯ  ƴϱ  
		//    ó 
        if(min != 0) {
            if(schedule[wday][hour-1]) {
				//  е ˶  Ͽ  
				alarm((60-min)*60);
				fprintf(stdout, " Enable mode for %d minutes\n", 60-min);
				return;
			} else {
				//  е 
				fprintf(stdout, " Disable mode for %d minutes\n", 60-min);
				sleep((60-min)*60);
            }
        } 
		// ϶ ó
        else {
			if(schedule[wday][hour-1]) {
				// ˶  ðķ   Ͽ  
				alarm(3600);
				fprintf(stdout, " Enable mode for 1 hour\n");
				return;
			} else {
				fprintf(stdout, " Disable mode for 1 hour\n");
				//  ð     üũ
				sleep(3600);
			}
		}
    }
}

void set_ip_forward(int flag)
{

	int fd;

    if((fd = open(IP_FORWARD_PATH,O_WRONLY)) < 0) {
		fprintf(stderr, "Can't open %s\n", IP_FORWARD_PATH);
		exit(1);
    }

	if ( flag )
		write(fd, "1", 1);		// 	enable ip_forward
	else
		write(fd, "0", 1);		// disable ip_forward
}
